; logic.asm - logic operations



INVERT  ;( x1 -- x2 , Logical inverse )
        not     cell tosreg
        ret
end INVERT


_AND    ;( x1 x2 -- x3 )
        push    eax
        upop    eax
        and     tosreg, eax
        pop     eax
        ret
end _AND


_OR     ;( x1 x2 -- x3 )
        push    eax
        upop    eax
        or      tosreg, eax
        pop     eax
        ret
end _OR


_XOR    ;( x1 x2 -- x3 )
        push    eax
        upop    eax
        xor     tosreg, eax
        pop     eax
        ret
end _XOR


LSHIFT  ;( x1 u -- x2 , Left shift x1 by u bits )
        push    ecx
        upop    ecx
        shl     cell tosreg, cl
        pop     ecx
        ret
end LSHIFT


RSHIFT  ;( x1 u -- x2 , Right shift x1 by u bits [logical, not arithmetic] )
        push    ecx
        upop    ecx
        shr     cell tosreg, cl
        pop     ecx
        ret
end RSHIFT



